//=========================================================================
// C++ Builder Designpattern  Builder.cpp
//=========================================================================
#include "stdafx.h"
#include <iostream>
#include "BUMeasurementMeter.h"
#include "BUMeasurementYard.h"
#include "BUMeasurementInch.h"
#include "BUBuilderMeter2Inch.h"
#include "BUBuilderMeter2Yard.h"

using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
   BUMeasurementMeter rMeter(1.0);
   BUMeasurementYard  *rYard  = NULL;
   BUMeasurementInch  *rInch  = NULL;

   BUBuilderMeter2Inch rM2I;
   BUBuilderMeter2Yard rM2Y;

   rMeter.setBuilder(&rM2Y);
   rYard = (BUMeasurementYard *)rMeter.build();
   cout << "Yards: " << rYard->get() << endl;
   
   rMeter.setBuilder(&rM2I);
   rInch = (BUMeasurementInch *)rMeter.build();
   cout << "Inch: " << rInch->get() << endl;

   delete rYard;
   delete rInch;

	return 0;
}

