//=========================================================================
// C++ Command Designpattern  Command.cpp
//=========================================================================
#include "stdafx.h"
#include <vector>
#include <iostream>
#include "CMKreis.h"
#include "CMPunkt.h"
#include "CMRechteck.h"
#include "CMCommandResize.h"
#include "CMCommandFillcolor.h"
#include "CMCommandLinecolor.h"

using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
   vector<ICMCommandListener*> vCommandListener;
   ICMCommandListener* rListener = NULL;
   CMCommandResize     rResize; 
   CMCommandFillcolor  rFill; 
   CMCommandLinecolor  rLine; 
   rResize.setData("0.5");
   rFill.setData("#FF0000");
   rLine.setData("#00FF00");

   CMKreis *rKreis1 = new CMKreis( 50,  50, 100);
   vCommandListener.push_back(rKreis1);
   CMKreis *rKreis2 = new CMKreis( 20,  20,  11);
   vCommandListener.push_back(rKreis2);

   CMPunkt *rPunkt1 = new CMPunkt(10, 10);
   vCommandListener.push_back(rPunkt1);
   CMPunkt *rPunkt2 = new CMPunkt(100, 100);
   vCommandListener.push_back(rPunkt2);

   CMRechteck *rRechteck1 = new CMRechteck( 25,  25, 125, 125);
   vCommandListener.push_back(rRechteck1);
   CMRechteck *rRechteck2 = new CMRechteck(200, 200, 300, 300);
   vCommandListener.push_back(rRechteck2);
   
   //---------------------------------------------------------------------
   // Ausgeben
   //---------------------------------------------------------------------
   for (unsigned int i=0; i<vCommandListener.size(); i++)
   {
      rListener = vCommandListener[i];
      cout << rListener->showContent() << endl;
   }
   cout << "----------------------" << endl;

   //---------------------------------------------------------------------
   // Gre ndern
   //---------------------------------------------------------------------
   for (unsigned int i=0; i<vCommandListener.size(); i++)
   {
      rListener = vCommandListener[i];
      rListener->doCommand(&rResize); 
   }

   //---------------------------------------------------------------------
   // Ausgeben
   //---------------------------------------------------------------------
   for (unsigned int i=0; i<vCommandListener.size(); i++)
   {
      rListener = vCommandListener[i];
      cout << rListener->showContent() << endl;
   }
   cout << "----------------------" << endl;

   //---------------------------------------------------------------------
   // Farben ndern
   //---------------------------------------------------------------------
   for (unsigned int i=0; i<vCommandListener.size(); i++)
   {
      rListener = vCommandListener[i];
      rListener->doCommand(&rFill); 
      rListener->doCommand(&rLine); 
   }

   //---------------------------------------------------------------------
   // Ausgeben
   //---------------------------------------------------------------------
   for (unsigned int i=0; i<vCommandListener.size(); i++)
   {
      rListener = vCommandListener[i];
      cout << rListener->showContent() << endl;
   }
   cout << "----------------------" << endl;

   //---------------------------------------------------------------------
   // Freigeben
   //---------------------------------------------------------------------
   for (unsigned int i=0; i<vCommandListener.size(); i++)
   {
      delete vCommandListener[i];
   }
   return 0;
}

