//=========================================================================
// C++ Decorator Designpattern - DCWareUS.cpp
//=========================================================================
#include "stdafx.h"        // Entfernen fr Borland
#include <assert.h>
#include "DCDecoratorUS.h"
#include "DCWare.h"

//-------------------------------------------------------------------------
// Constructor
//-------------------------------------------------------------------------
DCDecoratorUS::DCDecoratorUS (DCWare & rNewWare) : DCDecoratorWareBasis (rNewWare) 
{
}

//-------------------------------------------------------------------------
// Destructor
//-------------------------------------------------------------------------
DCDecoratorUS::~DCDecoratorUS ()
{
}

//-------------------------------------------------------------------------
// getVKPreis (void)
//-------------------------------------------------------------------------
double DCDecoratorUS::getVKPreis (void)
{
   return pWare->getEKPreis() * getProfitfactor() + getTax();
}

//-------------------------------------------------------------------------
// getTax (void)
//-------------------------------------------------------------------------
double DCDecoratorUS::getTax (void)
{
   return pWare->getEKPreis() * getCountyTaxfactor() +
          pWare->getEKPreis() * getStateTaxfactor()  +
          pWare->getEKPreis() * getFederalTaxfactor();
}

//-------------------------------------------------------------------------
// getStateTaxfactor(void)
//-------------------------------------------------------------------------
double DCDecoratorUS::getStateTaxfactor (void)
{
   return 0.07; // BESSER: aus externer Datenbank lesen
}

//-------------------------------------------------------------------------
// getFederalTaxfactor (void)
//-------------------------------------------------------------------------
double DCDecoratorUS::getFederalTaxfactor (void)
{
   return 0.04; // BESSER: aus externer Datenbank lesen
}

//-------------------------------------------------------------------------
// getCountyTaxfactor (void)
//-------------------------------------------------------------------------
double DCDecoratorUS::getCountyTaxfactor (void)
{
   return 0.05; // BESSER: aus externer Datenbank lesen
}
