//=========================================================================
// C++ Factory Designpattern  FAFactory.cpp
//=========================================================================
#include "stdafx.h"
#include "FAFactory.h"
#include <iostream>

// Beim Erzeugen ber dynamische Link-Libraries (DLLs) 
// entfallen diese includes
#include "FAKreis.h"
#include "FARechteck.h"
#include "FALinie.h"

using namespace std;

FAFactory::FAFactory (void)
{
   // Dies wrde man aus einer Konfigurationsdatei lesen
   vElemente.push_back ("Kreis");
   vElemente.push_back ("Rechteck");
   vElemente.push_back ("Linie");
}

// Das Erzeugen wrde man ber dynamische Link-Libraries (DLLs) machen
FAGraphicElement* FAFactory::create(string pElement)
{
   cout << "create: " << pElement << endl;
   FAGraphicElement* rRC = NULL;

   if (pElement == "Kreis")
   {
      rRC = new FAKreis();
   }
   else if (pElement == "Rechteck")
   {
      rRC = new FARechteck();
   }
   if (pElement == "Linie")
   {
      rRC = new FALinie();
   }
   return rRC;
}

//----------------------------------------------------------------------
const vector<string> FAFactory::getElemente(void)
{
   return vElemente;
}

