//=========================================================================
// C++ Flyweight Designpattern  FLFilereaderFlyweight.cpp
//=========================================================================
#include "stdafx.h"
#include <fstream>
#include "FLFilereaderFlyweight.h"

using namespace std;

//----------------------------------------------------------------------
FLFilereaderFlyweight::FLFilereaderFlyweight(string pFilename)
{
   setFilename(pFilename);
   bRead = false;
}

//----------------------------------------------------------------------
string FLFilereaderFlyweight::getFilename (void)
{
   return sFilename;
}

//----------------------------------------------------------------------
void FLFilereaderFlyweight::setFilename (string pFilename)
{
   if (sFilename != pFilename)
   {
      sFilename = pFilename;
      bRead = false;
   }
}

//----------------------------------------------------------------------
string FLFilereaderFlyweight::getText (void)
{
   if (!bRead)
   {
      string sTemp;
      cout << "*** Text not in Memory - now Loading: " << sFilename << endl;
      ifstream rInput;
      rInput.open(sFilename.c_str());

      if (!rInput.fail())
      {
         while (!rInput.eof())
         {
            rInput >> sTemp;
            sText.append(sTemp);
            sText.append("\n");
         }
         rInput.close();
         bRead = true;
      }
      cout << sText << endl;
   }
   else
   {
      cout << "*** Text in Memory - no Loading needed: " << sFilename << endl;
   }
   return sText;
}

ostream& operator<< (ostream& out, const FLFilereaderFlyweight& f)
{
   out << f.sFilename;
   if (!f.bRead)
   {
      out << " not read yet" << endl;
   }
   else
   {
      out << "Lenght: " + f.sText.length() << endl;
   }
   return out;
}