//=========================================================================
// C++ Prototype Designpattern  Prototype.cpp
//=========================================================================
#include "stdafx.h"
#include "PRKreis.h"
#include "PRLinie.h"
#include "PRRechteck.h"
#include <time.h>
#include <stdlib.h>

PRGraphicElement* aElements [10];
PRGraphicElement* aCopy     [10];

int _tmain(int argc, _TCHAR* argv[])
{
   srand ((unsigned)time(NULL));

   // 10 zufllige Elemente erzeugen
   for (int i=0; i<10; i++)
   {
      switch (rand() % 3)
      {
         case  0:
               aElements [i] = new PRKreis(rand(), rand(), rand()); 
               break;
         case  1:
               aElements [i] = new PRLinie(rand(), rand(), 
                                           rand(), rand()); 
               break;
         case  2:
               aElements [i] = new PRRechteck(rand(), rand(), 
                                              rand(), rand()); 
               break;
      }
   }
      
   // 10 erzeugte Elemente ausgeben
   for (int i=0; i<10; i++)
   {
      cout << aElements[i]->showContent() << endl;
   }
   cout << "-----------------------" << endl;
   
   // Die 10 zufllig erzeugten Elemente kopieren
   for (int i=0; i<10; i++)
   {
      aCopy[i] = aElements[i]->clone();
   }

   // Die 10 kopierten Elemente ausgeben
   for (int i=0; i<10; i++)
   {
      cout << aCopy[i]->showContent() << endl;
   }

   // 10 Elemente wieder freigeben
   for (int i=0; i<10; i++)
   {
      delete aElements[i];
      aElements[i] = NULL;
      delete aCopy[i];
      aCopy[i] = NULL;
   }

   return 0;
}

