//=========================================================================
// C++ Proxy Designpattern  PXAdministratorProxy.cpp
//=========================================================================
#include "stdafx.h"
#include "PXAdministratorProxy.h"
#include <iostream>

using namespace std;
   
//----------------------------------------------------------------------
PXAdministratorProxy::PXAdministratorProxy(PXDatalist *pList)
{
   rList = pList;
}

//----------------------------------------------------------------------
void PXAdministratorProxy::anlegen (string pVorname, string pNachname, int pKdNr)
{
   PXDatalistItem rTemp(pVorname, pNachname, pKdNr);
   rList->add(rTemp);
}
   
//----------------------------------------------------------------------
void PXAdministratorProxy::aendern (int pIdx, string pVorname, string pNachname, int pKdNr)
{
   rList->get(pIdx).setVorname(pVorname);
   rList->get(pIdx).setNachname(pNachname);
   rList->get(pIdx).setKundenNr(pKdNr);
}
   
//----------------------------------------------------------------------
void PXAdministratorProxy::loeschen (int pIdx)
{
   rList->remove(pIdx); 
}
   
//----------------------------------------------------------------------
void PXAdministratorProxy::anzeigen (int pIdx)
{
   cout << rList->get(pIdx).getNachname() << ", " 
        << rList->get(pIdx).getVorname() 
        << " (" << rList->get(pIdx).getKundenNr() << ")" << endl;
}
   
//----------------------------------------------------------------------
void PXAdministratorProxy::anzeigen (void)
{
   for (unsigned int i=0; i<rList->size(); i++)
   {
      anzeigen(i);
   }
}
