//=========================================================================
// C++ Proxy Designpattern  Proxy.cpp
//=========================================================================
#include "stdafx.h"
#include <iostream>
#include "PXDatalist.h"
#include "PXAdministratorProxy.h"
#include "PXVisitorProxy.h"

int _tmain(int argc, _TCHAR* argv[])
{
   // Testdaten erzeugen
   PXDatalist rData; 
   rData.add(PXDatalistItem("Donald",   "Duck", 1));
   rData.add(PXDatalistItem("Dagobert", "Duck", 2));
   rData.add(PXDatalistItem("Micky",    "Maus", 3));
   rData.add(PXDatalistItem("Minnie",   "Maus", 4));
      
   // Visitor-Proxy fr Datenzugriff erzeugen
   PXVisitorProxy rVisitor(&rData);
   cout << "--- VISITOR 1 ---" << endl;
   rVisitor.anzeigen();
   rVisitor.anlegen("Gustav", "Gans", 5);
   rVisitor.aendern(0, "Daisy", "Duck", 1);
   rVisitor.loeschen(2);
   cout << "\n--- VISITOR 2 ---" << endl;
   rVisitor.anzeigen();

   // Administrator-Proxy fr Datenzugriff erzeugen
   PXAdministratorProxy rAdmin(&rData);
   cout << "\n--- ADMINISTRATOR 1 ---" << endl;
   rAdmin.anzeigen();
   rAdmin.anlegen("Gustav", "Gans", 5);
   rAdmin.aendern(0, "Daisy", "Duck", 1);
   rAdmin.loeschen(2);
   cout << "\n--- ADMINISTRATOR 2 ---" << endl;
   rAdmin.anzeigen();
	return 0;
}

