//=========================================================================
// C++ Singleton Designpattern - SISystemkonstanten.cpp
//=========================================================================
#include "stdafx.h"        // Entfernen fr Borland
#include "SISystemkonstanten.h"

SISystemkonstanten * SISystemkonstanten::pSingleton = NULL;

//-------------------------------------------------------------------------
// Constructor
//-------------------------------------------------------------------------
SISystemkonstanten::SISystemkonstanten ()
{
   // Auslesen der Konstanten aus einer Datenbank oder Konfigurationsdatei
   fMWSTFaktor = 0.17;
}

//-------------------------------------------------------------------------
// Destructor
//-------------------------------------------------------------------------
SISystemkonstanten::~SISystemkonstanten ()
{
}

//-------------------------------------------------------------------------
// Singleton ansprechen (ggf. indirekter Constructoraufruf)
//-------------------------------------------------------------------------
const SISystemkonstanten * SISystemkonstanten::get (void)
{
   if (!pSingleton)
   {
      pSingleton = new SISystemkonstanten();
   }
   return pSingleton;
}

//-------------------------------------------------------------------------
// indirekter Destructoraufruf
//-------------------------------------------------------------------------
void SISystemkonstanten::remove (void)
{
   if (pSingleton)
   {
      delete pSingleton;
      pSingleton = NULL;
   }
}

//-------------------------------------------------------------------------
// Beispielkonstante abfragen
//-------------------------------------------------------------------------
const double SISystemkonstanten::getMWSTFaktor (void)
{
   return get()->fMWSTFaktor;
}
